#!/bin/bash

. /etc/fenix-release

if [ "$BOARD" == "VIM4" ]; then
	sleep 5
	if cat /proc/cpu_chipid | grep -q "360b"; then
		# VIM4
		attempts=0
		max_attempts=10
		interval=3

		while [ $attempts -lt $max_attempts ]; do
			if [ -e /dev/video50 ]; then
				/usr/local/bin/iv009_isp -n 2
				exit 0 
			else
				attempts=$((attempts + 1))
				sleep $interval
			fi
		done
		exit 1
	fi
elif [ "$BOARD" == "VIM3" ]; then
	
	modprobe iv009_isp_iq_g12b
	modprobe iv009_isp_lens_g12b
	modprobe iv009_isp_sensor_g12b
	modprobe iv009_isp_g12b

	if [ -e /dev/video50 ]; then
		/usr/local/bin/iv009_isp-g12b
	fi
fi

exit 0

